#ifndef PARSER_H
#define PARSER_H


#include <QWidget>
#include <QtGui>
#include <QtNetwork/QNetworkAccessManager>
#include "tnotify.h"
#include "tthread.h"
#include "tthreadlist.h"

class parser : public QWidget
{
    Q_OBJECT
public:
    explicit parser(QWidget *parent = 0);
    static QString getTitleFromReply(QString data);
    static QString toUnicode (QString str);
    static QString getMessageFromReply(QString data);
    void addNotify(void);
    void deleteNotify(void);

private:
    QLineEdit* url;
    QPushButton* addButton;
    QPushButton* deleteButton;
    QPushButton* startAllButton;
    QPushButton* startButton;
    QPushButton* ondemandButton;
    QPushButton* stopButton;
    QPushButton* testButton;
    TThreadList* listView;
    QGridLayout* grid;
    QNetworkAccessManager* nm;
    TNotify* notifications;
    int notificationNum;

signals:

public slots:
    void addURL(void);
    void deleteURL(void);

private slots:
    void start(void);
    void startAll(void);
    void stop(void);
    void test(void);
};

#endif // PARSER_H
